/**************************************************************************
esListe2.cpp

  Scrivere un programma che gestisce una playlist.
  La playlist contiene una lista di album musicali.
  Ogni album musicale e' caratterizzato da
  un titolo univoco (lunghezza massima: 63 caratteri).
  All'inizio la Playlist  vuota.

  Utilizzare la seguente struttura dati:

  struct elem {
	  char titolo[64];  
	  elem* pun;      
  };

  Realizzare le seguenti funzioni:

- stampa(L): funzione che stampa tutti gli album 
    contenuti nella playlist L.

- aggiungi(L, alb): funzione che aggiunge l'album 
	 di nome alb alla playlist L. 
     La funzione restituisce true se alb viene inserito correttamente in L 
      (ovvero, se alb NON era gia' presente nella playlist). 
      Altrimenti, restituisce false.

Utilizzare il seguente main di prova:
 
int main() {

	elem *L0;

	L0=null; // Playlist vuota
	stampa(L0);

	//test aggiungi
	aggiungi(L0, "titolo1 (autore1)");
	aggiungi(L0, "titolo2 (autore1)");
	aggiungi(L0, "titolo3 (autore2)");
	aggiungi(L0, "titolo2 (autore1)"); //non viene aggiunto perche' 
	                                   //gia' presente
	stampa(L0);
	return 0;
}

********************************************************
VERSIONE COMPLETA DELL'ESERCIZIO
********************************************************

Implementare le seguenti funzioni aggiuntive:

- elimina(L, alb): funzione che elimina l'album di nome alb 
  dalla playlist L. 
  La funzione restituisce true se alb viene eliminato correttamente da L
  (ovvero, se alb era presente nella lista). Altrimenti, restituisce false.

- cerca(L, alb): funzione che cerca l'album di nome alb all'interno 
  della playlist L. Se alb viene trovato, la funzione restituisce true. 
  Altrimenti, restituisce false.

- scrivi(L, F): funzione che scrive sul file di nome F tutti 
  gli album contenuti nella playlist L.

- distruggi(L): funzione che cancella tutto il contenuto della playlist L.

Il main di test da utilizzare per la versione completa e' il seguente:

int main() {

  elem* L0;

  L0=null; // Playlist vuota
  stampa(L0);

  //test aggiungi
  aggiungi(L0, "titolo1 (autore1)");
  aggiungi(L0, "titolo2 (autore1)");
  aggiungi(L0, "titolo3 (autore2)");
  aggiungi(L0, "titolo2 (autore1)"); //non viene aggiunto perche' gia' presente

  stampa(L0);
	
  //test elimina
  elimina(L0, "titolo2 (autore1)");
  elimina(L0, "titolo8 (autore1)"); 

  //non viene rimosso perche' non presente
  stampa(L0);

  //test cerca
  cout<<cerca(L0, "titolo2 (autore1)")<<endl; //visualizza 1
  cout<<cerca(L0, "titolo5 (autore1)")<<endl; //visualizza 0

  //test scrivi
  scrivi(L0, "playlist.txt");

  //test distruggi
  distruggi(L0);
  stampa(L0);

  return 0;

}

**************************************************************/

#include <iostream>
#include <cstdlib>
#include <fstream>
#include <cstring>
using namespace std;

struct elem {
	char titolo[64];  
	elem* pun;       
};

void stampa(elem* L) {
	elem* p = L;
	cout<<"Album della playlist:"<<endl;
	while(p!=NULL) {
		cout<<p->titolo<<endl;
		p = p->pun;
	}
	cout<<endl;
}

bool aggiungi(elem*& L, const char* alb) {
	//controllo se album gia' presente
	elem* p = L;
	while(p!=NULL) {
		if(strcmp(p->titolo,alb)==0) { return false; }
		p = p->pun;
	}
	//inserimento in testa
	p = L;
	L = new elem;
	strcpy(L->titolo, alb);
	L->pun = p;
	return true;
}

int main() {

	elem *L0;
  L0 = NULL;

	stampa(L0);

	//test aggiungi
	aggiungi(L0, "titolo1 (autore1)");
	aggiungi(L0, "titolo2 (autore1)");
	aggiungi(L0, "titolo3 (autore2)");
	aggiungi(L0, "titolo2 (autore1)"); //non viene aggiunto perche' gia' presente
	stampa(L0);
  
	return 0;
}
