/************************************************************
esListe2PerCasa.cpp

Aggiungere le seguenti funzionalita' al programma
esListe2.cpp:

- elimina(L, alb): funzione che elimina l'album di nome alb 
  dalla playlist L. 
  La funzione restituisce true se alb viene eliminato correttamente da L
  (ovvero, se alb era presente nella lista). Altrimenti, restituisce false.

- cerca(L, alb): funzione che cerca l'album di nome alb all'interno 
  della playlist L. Se alb viene trovato, la funzione restituisce true. 
  Altrimenti, restituisce false.

- scrivi(L, F): funzione che scrive sul file di nome F tutti 
  gli album contenuti nella playlist L.

- distruggi(L): funzione che cancella tutto il contenuto della playlist L.

Utilizzare il seguente main per testare tutte le funzioni, comprese
quelle gia' definite in esListe2.cpp, ovviamente dopo averle riportate
anche in esListe2Completo.cpp:

int main() {

	elem * L0;

	L0=null; // Playlist vuota
	stampa(L0);

	//test aggiungi
	aggiungi(L0, "titolo1 (autore1)");
	aggiungi(L0, "titolo2 (autore1)");
	aggiungi(L0, "titolo3 (autore2)");
	aggiungi(L0, "titolo2 (autore1)"); 
                  //non viene aggiunto perche' gia' presente
	stampa(L0);
	
	//test elimina
	elimina(L0, "titolo2 (autore1)");
	elimina(L0, "titolo8 (autore1)"); 
                   //non viene rimosso perche' non presente
	stampa(L0);

	//test cerca
	cout<<cerca(L0, "titolo2 (autore1)")<<endl; //visualizza 1
	cout<<cerca(L0, "titolo5 (autore1)")<<endl; //visualizza 0

    //test scrivi
    scrivi(L0, "playlist.txt");

	//test distruggi
	distruggi(L0);
	stampa(L0);

	return 0;
}

********************************************************/


#include <iostream>
#include <cstdlib>
#include <fstream>
#include <cstring>
using namespace std;

struct elem {
	char titolo[64];  
	elem* pun;        
};


void stampa(elem* L) {
	elem* p = L;
	cout<<"Album della playlist:"<<endl;
	while(p!=NULL) {
		cout<<p->titolo<<endl;
		p = p->pun;
	}
	cout<<endl;
}

bool aggiungi(elem*& L, const char* alb) {
	//controllo se album gia' presente
	elem* p = L;
	while(p!=NULL) {
		if(strcmp(p->titolo,alb)==0) { return false; }
		p = p->pun;
	}
	//inserimento in testa
	p = L;
	L = new elem;
	strcpy(L->titolo, alb);
	L->pun = p;
	return true;
}



bool elimina(elem*& L, const char* alb) {
	elem* p = L;
	elem* q = p;
	while(q!=NULL && strcmp(q->titolo,alb)!=0) {
		p = q;
		q = q->pun;
	}
	if(q!=NULL) {
		if(q==L) {
			L = L->pun;
			delete q;
		}
		else {
			p->pun = q->pun;
			delete q;
		}
		return true;
	}
	return false;
}

bool cerca(elem* L, const char* alb) {
	elem* p = L;
	while(p!=NULL) {
		if(strcmp(p->titolo, alb)==0) { return true; }
		p = p->pun;
	}
	return false;
}

bool scrivi(elem* L, const char* F) {
	fstream fout;
	fout.open(F, ios::out);
	if(!fout) 
       { cout<<"errore nell'apertura di "<<F<<endl; 
          return false; }
	elem* p = L;
	while(p!=NULL) {
		fout<<p->titolo<<endl;
		p = p->pun;
	}
	fout.close();
	return true;
}

void distruggi(elem*& L) {
	while(L!=NULL) {
		elem* p = L;
		L = L->pun;
		delete p;
	}
}

int main() {

	elem* L0;
	L0 = NULL;
	stampa(L0);

	//test aggiungi
	aggiungi(L0, "titolo1 (autore1)");
	aggiungi(L0, "titolo2 (autore1)");
	aggiungi(L0, "titolo3 (autore2)");
     aggiungi(L0, "titolo2 (autore1)");
	 //non viene aggiunto perche' gia' presente
	stampa(L0);

	//test scrivi
    scrivi(L0, "playlist.txt");

	//test elimina
	elimina(L0, "titolo2 (autore1)");
	elimina(L0, "titolo8 (autore1)"); 
	  //non viene rimosso perche' non presente
	stampa(L0);

	//test cerca
	cout<<cerca(L0, "titolo2 (autore1)")<<endl; //visualizza 1
	cout<<cerca(L0, "titolo5 (autore1)")<<endl; //visualizza 0

	//test distruggi
	distruggi(L0);
	stampa(L0);

	return 0;
}


